import { useState, useEffect, Fragment } from 'react';
import Head from 'next/head';
import { parseCookies } from "nookies";

// Components
import {
  Grid,
  ProjectCard,
  Container,
  Banner,
  ParallaxContainer,
  Modal,
  ModalProjectCard,
  FakeBlock,
  Navigation,
} from '../components';

// Utils
import {
  SERVER_ENV_URL,
  SIZE_FAKE_BRICKS,
} from '../utils/constants';

const Home = ({ data }) => {
  const [activeFilter, setActiveFilter] = useState("all");
  const [projectsStash, setProjectsStash] = useState({});
  const [currentProject, setCurrentProject] = useState(null);
  const [flippingProjectIndex, setFlippingProjectIndex] = useState(null);
  const [projectsList, setProjectList] = useState(data?.projects);
  const [isShow, setIsShow] = useState(false);

  const getProject = async (id) => {
    let projectData = projectsStash[id];

    if (!projectData) {
      const res = await fetch(`${SERVER_ENV_URL}/api/project/${id}?Language=${data?.language}`);
      projectData = await res.json();

      setProjectsStash({
        ...projectsStash,
        [`${id}`]: projectData,
      });
    }

    setCurrentProject(projectData);
  }

  const flippingProject = (index) => {
    const projectId = data?.projects[index]?.id;
    setFlippingProjectIndex(index);
    getProject(projectId);
  }

  const filterProjects = (type) => {
    const filterList = type === 'all'
      ? data?.projects
      : data?.projects.filter(item => item.projectTypeIds.includes(type));

    setProjectList(filterList);
    setActiveFilter(type);
  }

  const setShowFakeBlocks = () => {
    let timer = null;
    timer = setTimeout(() => {
      setIsShow(!isShow);
      clearTimeout(timer);
    }, 1000);
  }

  useEffect(() => {
    setShowFakeBlocks();
  }, []);

  return (
    <Fragment>
      <Head>
        <title>Create Next App</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>

      <Navigation
        filtersOnCLick={filterProjects}
        activeFilter={activeFilter}
        filtersList={data?.filters}
        filtersType="filters"
      />

      <Container.Main>
        <main>
          <Container.Block
            paddingBottom
            maxWidth="1560px"
          >
            <div style={{
              opacity: isShow ? '0' : '1',
              display: isShow && 'none'
            }}>
              <Grid.Brick>
                {[1, 2, 3, 4, 5, 6, 7, 8, 9, 10].map((item, index) => (
                  <FakeBlock key={index} size={SIZE_FAKE_BRICKS[index]} />
                ))}
              </Grid.Brick>
            </div>

            <div style={{
              opacity: isShow ? '1' : '0'
            }}>
              {!!(projectsList?.length) && (
                <Grid.Brick>
                  {projectsList?.map((item) => (
                    <ProjectCard
                      language={data?.language}
                      onClick={() => getProject(item.id)}
                      onTypeClick={filterProjects}
                      key={item.id}
                      projectTypeList={data?.typeList}
                      {...item}
                    />
                  ))}
                </Grid.Brick>
              )}
            </div>
          </Container.Block>

          {data?.companyPrinciples && (
            <Container.Block
              verticalPadding
              maxWidth="100%"
            >
              <ParallaxContainer
                image={data?.companyPrinciples?.backgroundImage?.id}
                title={data?.companyPrinciples?.title}
                text={data?.companyPrinciples?.text}
                urls={data?.companyPrinciples?.urls}
                download={data?.companyPrinciples?.isFile}
                paddingTop={null}
                membrane
              />
            </Container.Block>
          )}

          {data?.banner && (
            <Container.Block
              horizontalPadding
              verticalPadding
            >
              <Banner
                type="vacancy"
                imgId={data?.banner?.backgroundImage?.id}
                title={data?.banner?.title}
                text={data?.banner?.text}
                urls={data?.banner?.urls}
                list={data?.banner?.list}
              />
            </Container.Block>
          )}

          {(currentProject !== null) && (
            <Modal onClick={() => setCurrentProject(null)}>
              <ModalProjectCard
                language={data?.language}
                callback={flippingProject}
                projectLength={data?.projects?.length}
                projectIndex={flippingProjectIndex}
                {...currentProject}
              />
            </Modal>
          )}
        </main>
      </Container.Main>
    </Fragment>
  )
};

export default Home;

Home.getInitialProps = async (ctx) => {
  const language = parseCookies(ctx).language || "Ru";

  const BLOCK_COMPANY_PRINCIPLES = 'CompanyPrinciples';
  const BLOCK_DEMANDED_VACANCIES = 'DemandedVacancies';
  const SEARCH_PARAMS = `?Language=${language}&SpecialBlockTypesFilter=${BLOCK_COMPANY_PRINCIPLES}&SpecialBlockTypesFilter=${BLOCK_DEMANDED_VACANCIES}`;

  let resProjectListData = null;
  let resProjectTypeListData = null;
  let resSpecialBlockListData = null;
  let resDemandedListData = null;

  let companyPrinciples = null;
  let demandedVacancies = null;

  try {
    const resProjectList = await fetch(`${SERVER_ENV_URL}/api/project/list?Language=${language}`);
    const resProjectTypeList = await fetch(`${SERVER_ENV_URL}/api/project/type/list?Language=${language}`);
    const resSpecialBlockList = await fetch(`${SERVER_ENV_URL}/api/special-block/list${SEARCH_PARAMS}`);
    const resDemandedList = await fetch(`${SERVER_ENV_URL}/api/vacancy/list/demanded?Language=${language}`);

    resProjectListData = await resProjectList.json();
    resProjectTypeListData = await resProjectTypeList.json();
    resSpecialBlockListData = await resSpecialBlockList.json();
    resDemandedListData = await resDemandedList.json();

    companyPrinciples = resSpecialBlockListData?.projectTypes?.filter(
      item => item?.specialBlockType === BLOCK_COMPANY_PRINCIPLES);

    demandedVacancies = resSpecialBlockListData?.projectTypes?.filter(
      item => item?.specialBlockType === BLOCK_DEMANDED_VACANCIES);
  } catch (err) {
    console.log('BASE PAGE ERROR ... ', err);
  }

  return {
    data: {
      language,
      typeList: resProjectTypeListData?.projectTypes,
      filters: [{
        id: "all",
        name: (language === "Ru" ? "Все проекты" : "All projects")
      }, ...resProjectTypeListData?.projectTypes],
      projects: resProjectListData?.projects,
      companyPrinciples: {...companyPrinciples[0]},
      banner: {
        ...demandedVacancies[0],
        list: resDemandedListData?.directions,
      }
    },
  };
};
